VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Window"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' ***********************************************
' * Copyright / Bitte lesen                     *
' ***********************************************
' *                                             *
' * Zusammengetragen, ediert & neu verfasst von *
' *     Wolfgang Ehrhardt                       *
' *         woeh@gmx.de                         *
' *                                             *
' * Dieser Code ist frei verfgbar, solange  er *
' * fr PRIVATE Zwecke genutzt wird.            *
' * Wird dieser Code oder Auszge daraus in ein *
' * Kommerzielles Produkt implantiert, bitte    *
' * ich um Kontaktaufnahme unter obig genannter *
' * Email-Adresse.                              *
' *                                             *
' * Ansonsten ist es erwnscht, das Funktionen  *
' * und Subs in andere Projekte implantiert     *
' * werden (Solange es fr private Zwecke ist!) *
' *                                             *
' * Das einzige, worum ich bitte, ist den       *
' * DLL-SourceCode nur komplett & vollstndig   *
' * weiterzugeben.                              *
' * (Bitte nicht meine Arbeit zerstckeln)      *
' *                                             *
' * Ansonsten wnsche ich Dir viel Spa         *
' * mit den Funktionen & Subs                   *
' *                                             *
' * *********************************************
Option Explicit

Private Declare Function FlashWindowEx Lib "user32" (pfwi As FLASHWINFO) As Boolean
Private Declare Function IsWindowVisibleA Lib "user32" Alias "IsWindowVisible" (ByVal Hwnd As Long) As Long
Private Declare Function SendMessageByNum& Lib "user32" Alias "SendMessageA" (ByVal Hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long)
Private Declare Function SendMessageByString Lib "user32" Alias "SendMessageA" (ByVal Hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Private Declare Function IsWindowEnabledA Lib "user32.dll" Alias "IsWindowEnabled" (ByVal Hwnd As Long) As Long
Private Declare Function WindowEnabled Lib "user32.dll" Alias "EnableWindow" (ByVal Hwnd As Long, ByVal fEnable As Long) As Long
Private Declare Function SetFocusA Lib "user32" Alias "SetFocus" (ByVal Hwnd As Long) As Long
Private Declare Function SendNotifyMessage Lib "user32" Alias "SendNotifyMessageA" (ByVal Hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function FindWindowA Lib "user32" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function GetForegroundWindow Lib "user32" () As Long
Private Declare Function GetFocus Lib "user32" () As Long
Private Declare Function GetLayeredWindowAttributes Lib "user32.dll" (ByVal Hwnd As Long, ByRef crKey As Long, ByRef bAlpha As Byte, ByRef dwFlags As Long) As Long
Private Declare Function GetWindowPlacement Lib "user32" (ByVal Hwnd As Long, lpwndpl As WINDOWPLACEMENT) As Long
Private Declare Function ReadProcessMemory Lib "kernel32" (ByVal hProcess As Long, ByVal lpBaseAddress As Any, lpBuffer As Any, ByVal nSize As Long, lpNumberOfBytesWritten As Long) As Long
Private Declare Function ProcessWriteA Lib "kernel32" Alias "WriteProcessMemory" (ByVal hProcess As Long, ByVal lpBaseAddress As Any, ByVal lpBuffer As Any, ByVal nSize As Long, ByVal lpNumberOfBytesWritten As Long) As Long
Private Declare Function AttachThreadInput Lib "user32" (ByVal idAttach As Long, ByVal idAttachTo As Long, ByVal fAttach As Long) As Long

Private Declare Sub MemoryBmove Lib "kernel32" Alias "RtlMoveMemory" (ByVal hpvDest As Any, ByVal hpvSource As Any, ByVal cbCopy As Long)

Public Type WINDOWINFO
    Hwnd        As Long
    EXENAME     As String
    TEXT        As String
    Class       As String
    TaskID      As Long
    Enabled     As Boolean
    Visible     As Boolean
    Parent      As Long
    TopParent   As Long
    ThreadID    As Long
    POS         As CONTROLPOSITION
    WINDOWSTATE As VbAppWinStyle
    Transparenz As Long
    isOnTop     As Boolean
    Buttons     As STANDARDBUTTONINFO
End Type

Private Type WINDOWPLACEMENT
    Length           As Long
    Flags            As Long
    showCmd          As Long
    ptMinPosition    As POINTAPI
    ptMaxPosition    As POINTAPI
    rcNormalPosition As RECT
End Type

Private Type FLASHWINFO
    cbSize    As Long
    Hwnd      As Long
    dwFlags   As Long
    uCount    As Long
    dwTimeout As Long
End Type

Public Sub Click(ByVal Hwnd As Long)
    Call SendMessageB(Hwnd, WM_LBUTTONDOWN, 0, 0&)
    Call SendMessageB(Hwnd, WM_LBUTTONUP, 0, 0&)
End Sub
Public Function CloseWindow(ByVal Hwnd As Long) As Boolean
    Dim TaskID As Long
        
    Const SC_CLOSE = &HF060

    Call SendMessage(Hwnd, WM_CLOSE, 0, 0)
    Call SendNotifyMessage(Hwnd, WM_SYSCOMMAND, SC_CLOSE, 0)
        
    Call GetWindowThreadProcessId(Hwnd, TaskID)
    
    CloseWindow = (Not TaskID)
    
End Function
Public Sub EnableWindow(ByVal Hwnd As Long, Enable As Boolean)
    Dim L As Long
    
    L = IIf(Enable, 1, 0)
    
    Call WindowEnabled(Hwnd, L)
    
End Sub
Public Function EXEmoduleByHwnd(ByVal Hwnd As Long, Optional FullPath As Boolean = False) As String
    Dim id As Long, Index As Long
    Dim PI() As PROCESSINFO
    
    Call GetWindowThreadProcessId(Hwnd, id)
    
    PI = DLL.SYSTEM.Get_ProcessList(FullPath)
    
    Index = basPModule.ProcessFind(PI, , id)
    
    If Index > -1 Then EXEmoduleByHwnd = PI(Index).EXENAME
    
Quit:

End Function
Public Function FindChild(ByVal ParentHwnd As Long, ByVal ChildClass As String) As Long
    FindChild = FindWindowEx(ParentHwnd, 0, ChildClass, vbNullString)
End Function
Public Function FindChildByText(ByVal ParentHwnd As Long, ByVal ChildClass As String, ByVal ChildText As String) As Long
    Dim Hwnd As Long
    Dim TEXT As String
    
    Hwnd = FindWindowEx(ParentHwnd, 0, ChildClass, vbNullString)
    TEXT = Get_Text(Hwnd)
    
    Do While TEXT <> ChildText
        Hwnd = GetWindow(Hwnd, 2)
        TEXT = Get_Text(Hwnd)
    Loop

    FindChildByText = Hwnd
    
End Function
Public Function FindWindow(Optional ClassName As String, Optional Caption As String) As Long
    
    If ClassName = "" Then ClassName = vbNullString
    If Caption = "" Then Caption = vbNullString
    
    FindWindow = FindWindowA(ClassName, Caption)
    
End Function
Public Function FindWindowByPhrase(ByVal Phrase As String, Optional FindExact As Boolean = True) As Long()
    Dim Hwnd() As Long, P As Long, A() As Long, x As Long
    Dim Txt As String
    
    Hwnd = Get_AllHwnd
    If Not FindExact Then Phrase = LCase$(Phrase)
    
    For P = 0 To UBound(Hwnd)
        Txt = Get_Text(Hwnd(P))
        If Not FindExact Then Txt = LCase$(Txt)
        
        If InStr(Txt, Phrase) > 0 Then
            ReDim Preserve A(x)
            A(x) = Hwnd(P)
            
            x = x + 1
        End If
    Next P

    FindWindowByPhrase = A

End Function
Public Function FlashWindow(ByVal Hwnd As Long, _
                            Optional FlashCount As Long = 3) As Boolean
    Dim FlashInfo As FLASHWINFO
    
    Const FLASHW_CAPTION = &H1
    Const FLASHW_TIMER = &H4

    With FlashInfo
        .cbSize = Len(FlashInfo)
        .dwFlags = FLASHW_CAPTION Or FLASHW_TIMER
        .dwTimeout = 0
        .Hwnd = Hwnd
        .uCount = FlashCount
    End With
    
    FlashWindow = FlashWindowEx(FlashInfo)

End Function
Public Function Get_ActiveWindow() As Long
    Get_ActiveWindow = GetActiveWindowA
End Function
Public Function Get_ActiveWindowExeName(Optional GetFullPath As Boolean) As String
    Get_ActiveWindowExeName = EXEmoduleByHwnd(Get_ActiveWindow, GetFullPath)
End Function
Public Function Get_ActiveWindowTitle() As String
   Get_ActiveWindowTitle = Get_Text(Get_ActiveWindow)
End Function
Public Function Get_AllHwnd() As Long()
    Dim L() As Long
    
    L = EnumAll
    Get_AllHwnd = L
    
End Function
Public Function Get_AllHwndByClass(ByVal Class As String) As Long()
    Dim L() As Long, Hwnd As Long, x As Long
    
    Hwnd = FindWindowA(Class, vbNullString)
    If Hwnd = 0 Then Exit Function
    
    ReDim L(0)
    L(0) = Hwnd
    
    x = 1
    
    Do While Hwnd <> 0
        Hwnd = GetWindow(Hwnd, GW_HWNDNEXT)
        
        If Get_Class(Hwnd) = Class Then
            ReDim Preserve L(x)
            L(x) = Hwnd
            
            x = x + 1
        End If
    Loop

    Get_AllHwndByClass = L
    
End Function
Public Function Get_AllHwndByText(ByVal TEXT As String, Optional FindExact As Boolean = True) As Long()
    Dim L() As Long, Hwnd As Long, x As Long
    Dim T$
    
    If Not FindExact Then TEXT = LCase$(TEXT)
    
    Hwnd = FindWindowA(vbNullString, TEXT)
    If Hwnd = 0 Then Exit Function
    
    ReDim L(0)
    L(0) = Hwnd
    
    x = 1
    
    Do While Hwnd <> 0
        Hwnd = GetWindow(Hwnd, GW_HWNDNEXT)
        T$ = IIf(FindExact, Get_Text(Hwnd), LCase$(Get_Text(Hwnd)))
        
        If T$ = TEXT Then
            ReDim Preserve L(x)
            L(x) = Hwnd
            
            x = x + 1
        End If
    Loop

    Get_AllHwndByText = L
    
End Function
Public Function Get_ChildWindows(ByVal Hwnd As Long) As Long()
    Get_ChildWindows = EnumChild(Hwnd)
End Function
Public Function Get_Class(ByVal Hwnd As Long) As String
    Dim Buffer As String
    Dim GetClas As Long
    
    Buffer = Space(250)
    GetClas = GetClassName(Hwnd, Buffer, 250)
    Get_Class = Left$(Buffer, GetClas)
    
End Function
Public Function Get_Focus() As Long
    Dim Result As Long, GetCurrentThreadId As Long
    Dim OtherThreadID As Long, Thread1 As Long, Thread2 As Long
        
    Thread1 = GetWindowThreadProcessId(GetDesktopWindow, GetCurrentThreadId)
    Thread2 = GetWindowThreadProcessId(GetForegroundWindow, OtherThreadID)
         
    If Thread1 <> Thread2 Then Call AttachThreadInput(Thread2, Thread1, True)
    
    Result = GetFocus()
    Get_Focus = Result
    
End Function
Public Function Get_ForegroundWindow() As Long
    Get_ForegroundWindow = GetForegroundWindow
End Function
Public Function Get_Parent(ByVal Hwnd As Long) As Long
    Get_Parent = GetParentA(Hwnd)
End Function
Public Function Get_Pos(ByVal Hwnd As Long) As CONTROLPOSITION
    Dim R As RECT
       
    Call GetWindowRect(Hwnd, R)
    
    With Get_Pos
        .Bottom = R.Bottom
        .Left = R.Left
        .Right = R.Right
        .Top = R.Top
    End With
    
End Function
Public Function Get_TaskID(ByVal Hwnd As Long) As Long
    Call GetWindowThreadProcessId(Hwnd, Get_TaskID)
End Function
Public Function Get_Text(ByVal Hwnd As Long) As String
    Dim GetTrim As Long
    Dim TrimSpace As String, GetString As String
    
    GetTrim = SendMessageByNum(Hwnd, WM_GETTEXTLENGTH, 0&, 0&)
    TrimSpace = Space$(GetTrim)
    GetString = SendMessageByString(Hwnd, WM_GETTEXT, GetTrim + 1, TrimSpace)
    
    Get_Text = TrimSpace
        
End Function
Public Function Get_ThreadID(ByVal Hwnd As Long) As Long
    Dim x As Long, Result As Long
    
    Result = GetWindowThreadProcessId(Hwnd, x)
    Get_ThreadID = Result

End Function
Public Function Get_TopParent(ByVal Hwnd As Long) As Long
        
    Do Until GetParentA(Hwnd) = 0
        Hwnd = GetParentA(Hwnd)
    Loop
    
    Get_TopParent = Hwnd
    
End Function
Public Function Get_Transparenz(ByVal Hwnd As Long) As Byte
    Call GetLayeredWindowAttributes(Hwnd, CLng(0), Get_Transparenz, CLng(0))
End Function
Public Function Get_WindowInfo(ByVal Hwnd As Long) As WINDOWINFO
    Dim Prop As Long

    Prop = GetWindowLongA(Hwnd, GWL_EXSTYLE)
    
    With Get_WindowInfo
        .Hwnd = Hwnd
        .EXENAME = EXEmoduleByHwnd(Hwnd)
        .TEXT = Get_Text(Hwnd)
        .Class = Get_Class(Hwnd)
        .TaskID = Get_TaskID(Hwnd)
        .Enabled = IsWindowEnabled(Hwnd)
        .Visible = isWindowVisible(Hwnd)
        .ThreadID = Get_ThreadID(Hwnd)
        .POS = Get_Pos(Hwnd)
        .WINDOWSTATE = Get_WindowState(Hwnd)
        .TopParent = Get_TopParent(Hwnd)
        .Transparenz = Get_Transparenz(Hwnd)
        .Parent = Get_Parent(Hwnd)
        .isOnTop = CBool(Prop And WS_EX_TOPMOST) * -1
        .Buttons = DLL.FORMS.StandardButton(Hwnd)
        
        If .Parent = 0 And .EXENAME <> "" Then .Parent = Hwnd
    End With
    
End Function
Public Function Get_WindowState(ByVal Hwnd As Long) As VbAppWinStyle
    Dim w As WINDOWPLACEMENT

    If GetWindowPlacement(Hwnd, w) = 0 Then
        Get_WindowState = -1
    Else
        Get_WindowState = w.showCmd
    End If

End Function
Public Function HasFocus(Hwnd As Long) As Boolean
    If Get_Focus = Hwnd Then HasFocus = True
End Function
Private Function Hwnd2pHandle(ByVal Hwnd As Long) As Long
    Dim TaskID As Long
    
    TaskID = Get_TaskID(Hwnd)
    Hwnd2pHandle = OpenProcess(PROCESS_ALL_ACCESS, False, TaskID)
    
End Function
Public Function isHwnd(ByVal Hwnd As Long) As Boolean
    If Get_TaskID(Hwnd) > 0 Then isHwnd = True
End Function
Public Function isTopParent(ByVal Hwnd As Long) As Boolean
    If GetParentA(Hwnd) = 0 Then isTopParent = True
End Function
Public Function IsWindowEnabled(ByVal Hwnd As Long) As Boolean
    If IsWindowEnabledA(Hwnd) Then IsWindowEnabled = True
End Function
Public Function isWindowVisible(ByVal Hwnd As Long) As Boolean
    If IsWindowVisibleA(Hwnd) Then isWindowVisible = True
End Function
Public Sub LockWindowUpdate(ByVal Hwnd As Long, LockWindow As Boolean)
    Dim wParam As Long
    
    wParam = IIf(LockWindow, 1, 0)

    Call SendMessage(Hwnd, WM_SETREDRAW, wParam, 0)
    
End Sub
Private Sub LPoke(ByVal dest As Long, ByVal PokeVal As Long)
    Dim addr As Long
    
    addr = VarPtr(PokeVal)
    Call MemoryBmove(dest, ByVal addr, 4)
   
End Sub
Public Function ProcessFind(ByVal Hwnd As Long, _
                            ByVal Str As String, _
                            ByVal StartAdress As Long, _
                            ByVal ReadLenght As Long) As Long
    Dim pHandle As Long, x As Long, bytValue As Long, Y As Long, P As Long
    Dim R$
    Dim Found As Boolean
    
    pHandle = Hwnd2pHandle(Hwnd)
    If pHandle = 0 Or ReadLenght < 1 Then Exit Function

    For x = 0 To ReadLenght Step 2
        Call ReadProcessMemory(pHandle, x + StartAdress, bytValue, 1, 0&)
        
        If Chr$(bytValue) = mID$(Str, 1, 1) Then
            Found = True
            R$ = mID$(Str, 1, 1)
            Y = 0
            
            For P = 2 To Len(Str)
                Call ReadProcessMemory(pHandle, StartAdress + P + x + Y, bytValue, 1, 0&)
                
                Y = Y + 1
                R$ = R$ & Chr$(bytValue)
                
                If InStr(Str, R$) <> 1 Then
                    Found = False
                    Exit For
                End If
            Next P
        
            If Found Then
                ProcessFind = x + StartAdress
                Exit Function
            End If
        End If
    Next x
    
Quit:
    ProcessFind = -1
    
End Function
Public Function ProcessRead(ByVal Hwnd As Long, _
                            ByVal StartAdress As Long, _
                            ByVal ReadLenght As Long) As String
    Dim pHandle As Long, P As Long, bytValue As Long
    Dim Result As String
    
    pHandle = Hwnd2pHandle(Hwnd)
    If pHandle = 0 Or ReadLenght < 1 Then Exit Function
    
    For P = 0 To ReadLenght Step 2
        Call ReadProcessMemory(pHandle, StartAdress + P, bytValue, 1, 0&)
        Result = Result & Chr$(bytValue)
    Next P
    
    ProcessRead = Result
    
Quit:

End Function
Public Function ProcessReplace(ByVal Hwnd As Long, _
                               ByVal Find As String, _
                               ByVal ReplaceWith As String, _
                               ByVal Adress As Long, _
                               ByVal ReadLenght As Long) As Boolean
    Dim Result As Long, AdrDest As Long, NewL As Long
    
    If Len(ReplaceWith) > Len(Find) Then ReplaceWith = mID$(ReplaceWith, 1, Len(Find))
    
    Result = ProcessFind(Hwnd, Find, Adress, ReadLenght)
    
    If Result > 0 Then
        NewL = Len(ReplaceWith) * 2
        AdrDest = Result - 4
    
        Call LPoke(AdrDest, NewL)
        Call ProcessWrite(Hwnd, Result, ReplaceWith)
    End If
    
Quit:

End Function
Public Function ProcessWrite(ByVal Hwnd As Long, _
                             ByVal Adress As Long, _
                             ByVal Str As String) As Boolean
    Dim pHandle As Long
    
    pHandle = Hwnd2pHandle(Hwnd)
    If pHandle = 0 Or Adress < 1 Then Exit Function

    Call ProcessWriteA(pHandle, Adress, strptr(Str), LenB(Str), 0&)

Quit:

End Function
Public Sub SendKeys(ByVal Hwnd As Long, ByVal TEXT As String)
    Dim P As Long, KeyCode As Long
    Dim R$
    
    For P = 1 To Len(TEXT)
        R$ = mID$(TEXT, P, 1)
        KeyCode = Asc(R$)
    
        Call SendMessageByNum(Hwnd, WM_CHAR, KeyCode, 0)
    Next P
    
Quit:
    
End Sub
Public Function Set_Focus(ByVal Hwnd As Long) As Long
    
    Set_Focus = SetFocusA(Hwnd)

End Function
Public Function Set_Parent(ByVal Hwnd As Long, ByVal NewParent As Long) As Boolean
    Dim Result  As Long
    
    Result = SetParentA(Hwnd, NewParent)
    If Result <> 0 Then Set_Parent = True
    
End Function
Public Function Set_Pos(ByVal Hwnd As Long, ByVal Top As Long, ByVal Left As Long) As Boolean
    Dim R As RECT
    
    Call GetWindowRect(Hwnd, R)
    
    If MoveWindow(Hwnd, Left, Top, R.Right - R.Left, _
                  R.Bottom - R.Top, 1) Then Set_Pos = True

End Function
Public Function Set_Text(ByVal Hwnd As Long, ByVal TEXT As String) As Boolean
    Set_Text = (SendMessageByString(Hwnd, WM_SETTEXT, 0, TEXT) > 0)
End Function
Public Sub Set_Transparenz(ByVal Hwnd As Long, ByVal Transparenz As Byte)
    
    If Transparenz > 254 Then Transparenz = 254
    Call DoTrans(Hwnd, Transparenz)
    
End Sub
Public Sub Set_WindowState(ByVal Hwnd As Long, Optional ByVal WindowStyle As VbAppWinStyle = vbNormalFocus)
    Call ShowWindow(Hwnd, WindowStyle)
End Sub
Public Function Set_XPstyle(Hwnd As Long, Optional ApplyStyle As Boolean = True) As Boolean
            
    If Not DLL.SYSTEM.XPstyleSupported Then
        Set_XPstyle = False
        Exit Function
    End If
    
    If ApplyStyle Then
        Call ActivateWindowTheme(Hwnd)
    Else
        Call DeactivateWindowTheme(Hwnd)
    End If
        
    Set_XPstyle = True

End Function
Public Function SnapShot(ByVal Hwnd As Long, Optional ErrorNumber As Long) As StdPicture
    Dim frm As New frmTMP
    Dim pic As StdPicture
    
    On Local Error GoTo Quit
    
    Load frm
    
    Set pic = frm.GetWindowHwnd(Hwnd)
    Set SnapShot = pic
    
Quit:
    ErrorNumber = Err.Number

    If Err.Number <> 0 Then Call ERROR(WIN, "SnapShot", Err.Number, Err.Description)

    Unload frm
    
    Set frm = Nothing
    Set pic = Nothing
    
    Err.Clear
    
End Function
Public Function StayOnTop(ByVal Hwnd As Long, Optional RemoveFromTop As Boolean = False) As Boolean
    Dim hWndInsertAfter As Long
    
    Const HWND_NOTOPMOST = -2

    If RemoveFromTop Then
        hWndInsertAfter = HWND_TOPMOST
    Else
        hWndInsertAfter = HWND_NOTOPMOST
    End If
    
    If SetWindowPos(Hwnd, hWndInsertAfter, 0, 0, 0, 0, SWP_NOSIZE Or SWP_NOMOVE) Then StayOnTop = True
    
End Function
Public Function TaskIDtoHwnd(TaskID As Long) As Long
    Dim H As Variant
    Dim P As Long, Hwnd As Long, Get_TaskID As Long
    
    H = Get_AllHwnd

    For P = LBound(H) To UBound(H)
        Call GetWindowThreadProcessId(H(P), Get_TaskID)
        
        If Get_TaskID = TaskID Then
            Hwnd = H(P)
            Hwnd = Get_TopParent(Hwnd)
            TaskIDtoHwnd = Hwnd
            
            Exit Function
        End If
    Next P

Quit:
    TaskIDtoHwnd = -1
    
End Function
Public Function TerminateThread(ByVal Hwnd As Long, Optional TaskID As Long) As Boolean
    Dim Thread As Long
    
    Const PROCESS_TERMINATE = &H1

    Thread = TaskID
    
    If Thread = 0 Then Call GetWindowThreadProcessId(Hwnd, Thread)
    
    Thread = OpenProcess(PROCESS_TERMINATE, 0, Thread)
    
    TerminateThread = (TerminateProcess(Thread, 1) <> 0)
    
    Call CloseHandle(Thread)

End Function
Public Sub tFade(ByVal Hwnd As Long, _
                 ByVal FadeStart As Byte, ByVal FadeStop As Byte, _
                 Optional StartAtCurrentTransparenz As Boolean = False, _
                 Optional FadeStep As Integer = 5, _
                 Optional Speed As Integer = 3)
    Dim i As Integer
      
    If StartAtCurrentTransparenz Then
        FadeStart = Get_Transparenz(Hwnd)
        
        If FadeStart = 0 Then FadeStart = 254
    End If
        
    If FadeStart = 255 Then FadeStart = 254
    
    If FadeStop < FadeStart Then FadeStep = FadeStep * (-1)
    
    For i = FadeStart To FadeStop Step FadeStep
        Call DoTrans(Hwnd, i)
                
        Wait (Speed * 1000) / 2
    Next i

End Sub
Public Function Get_GlobalPosition(ByVal Hwnd As Long) As Position
    Dim P As POINTAPI
    
    P.x = 0: P.Y = 0
    
    Call ClientToScreen(Hwnd, P)
    
    Get_GlobalPosition.x = P.x
    Get_GlobalPosition.Y = P.Y
    
End Function
Public Function Hwnd_Exist(ByVal Hwnd As Long) As Boolean
    Hwnd_Exist = (Get_TaskID(Hwnd) <> 0)
End Function
