VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "mString"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function OemToCharA Lib "user32.dll" (ByVal lpszSrc As String, ByVal lpszDst As String) As Long
Private Declare Function CharToOemA Lib "user32.dll" (ByVal lpszSrc As String, ByVal lpszDst As String) As Long

Public Enum InStrPosition
    itFIRST = -1
    itLast = -2
End Enum

Public Enum DATATYPE
    dtBYTE = 0
    dtINTEGER = 1
    dtLONG = 2
    dtSINGLE = 4
    dtDOUBLE = 8
    dtDATE = 16
    dtALPHA = 32
    dtNUMERIC = 64
    dtCURRENCY = 128
End Enum

Public Enum BYTEINFO
    bi8BYTEHEX = 0
    bi16BYTEHEX = 1
End Enum
Public Function Text_EnCrypt(ByVal TEXT As String, ByVal Password As String) As String
    Text_EnCrypt = Crypt(TEXT, Password, True)
End Function
Public Function Text_DeCrypt(ByVal TEXT As String, ByVal Password As String) As String
    Text_DeCrypt = Crypt(TEXT, Password, False)
End Function
Public Function Str_ToHex(ByVal Str As String, StrTo As BYTEINFO)
    
    Select Case StrTo
        Case bi8BYTEHEX:  Str_ToHex = toHex(8, Str)
        Case bi16BYTEHEX: Str_ToHex = toHex(16, Str)
        
        Case Else
            '
    End Select

End Function
Public Function Str_toANSI(ByVal Str As String) As String
    Call OemToCharA(Str, Str)
    Str_toANSI = Str
End Function
Public Function Str_toASCII(ByVal Str As String) As String
    Call CharToOemA(Str, Str)
    Str_toASCII = Str
End Function
Public Function Str_Reverse(ByVal Str As String) As String
    Str_Reverse = VBA.StrReverse(Str)
End Function
Public Function Str_toCHR(ByVal Str As String) As String()
    Dim P As Long
    Dim A() As String, R$
    
    ReDim A(Len(Str) - 1)
    
    For P = 1 To Len(Str)
        R$ = mID$(Str, P, 1)
        A(P - 1) = R$
    Next P
    
    Str_toCHR = A
    
End Function
Public Function LineCount(ByVal Str As String) As Long
    Dim A() As String
    
    A = Split(Str, vbCrLf)
    
    If UBound(A) > -1 Then LineCount = UBound(A) + 1
    
End Function
Public Function Get_Line(ByVal Str As String, ByVal Line As Long) As String
    Dim S() As String
    
    Line = Line - 1
    
    S = Split(Str, vbCrLf)
    
    If (Line <= UBound(S)) And (UBound(S) > -1) Then Get_Line = S(Line)
        
End Function
Public Function StringCount(ByVal TEXT As String, ByVal SearchFor As String, _
                            Optional SearchExact As Boolean = True, _
                            Optional WholeWordsOnly As Boolean = False, _
                            Optional ErrorNumber As Long) As Long
  
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If TEXT = "" Then Exit Function

    If Not SearchExact Then
        TEXT = LCase$(TEXT)
        SearchFor = LCase$(SearchFor)
    End If
    
    If WholeWordsOnly Then
        SearchFor = " " & SearchFor & " "
        TEXT = " " & TEXT & " "
    End If
    
    StringCount = (Len(TEXT) - Len(Replace(TEXT, SearchFor, ""))) / Len(SearchFor)
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    StringCount = -2
        
    Call ERROR(mString, "StringCount", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Str_toASC(ByVal Str As String) As String()
    Dim P As Long
    Dim S$, A() As String
    
    ReDim A(Len(Str) - 1)
    
    For P = 1 To Len(Str)
        S$ = CStr(Asc(mID$(Str, P, 1)))
        A(P - 1) = S$
    Next P
    
    Str_toASC = A
    
End Function
Public Function Str_Cut(ByVal Str As String, ByVal StrToCut, _
                        Optional CutFromRight As Boolean = False, _
                        Optional CutAll As Boolean = False, _
                        Optional ErrorNumber As Long) As String
    Dim POS As Long, x As Long
    Dim S$, R$
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If CutAll Then
        R$ = Replace(Str, StrToCut, "")
        Str_Cut = R$
    
        Exit Function
    End If
    
    If CutFromRight Then
        x = 1
        
        Do While InStr(x, Str, StrToCut)
            POS = InStr(x, Str, StrToCut)
            x = POS + Len(StrToCut)
        Loop
    Else
        POS = InStr(Str, StrToCut)
    End If
    
    If POS Then
        R$ = mID$(Str, 1, POS - 1)
        S$ = mID$(Str, POS + Len(StrToCut))
            
        Str_Cut = R$ & S$
    End If

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(mString, "Str_Cut", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Get_RandomString(ByVal strLenght As Long, _
                                 Optional inclNum As Boolean = True, _
                                 Optional inclLAlpha As Boolean = True, _
                                 Optional inclUAlpha As Boolean = True, _
                                 Optional Space As Boolean = True, _
                                 Optional Other As Boolean = False) As String
    Dim A(3) As String, S$, T$
    Dim P As Long
        
    If strLenght < 1 Then Exit Function

    A(0) = Num
    A(1) = lABC
    A(2) = uABC
    A(3) = Chr$(32)
    
    If Other Then
        For P = 0 To 255
            S$ = S$ & Chr$(P)
        Next P
    
        If Not inclNum Then S$ = Replace(S$, A(0), "")
        If Not inclLAlpha Then S$ = Replace(S$, A(1), "")
        If Not inclUAlpha Then S$ = Replace(S$, A(2), "")
        If Not Space Then S$ = Replace(S$, A(3), "")
    Else
        If inclNum Then S$ = A(0)
        If inclLAlpha Then S$ = S$ & A(1)
        If inclUAlpha Then S$ = S$ & A(2)
        If Space Then S$ = S$ & A(3)
    End If
        
    For P = 1 To strLenght
        T$ = T$ & mID$(S$, DLL.MISC.Get_Randomize(1, Len(S$)), 1)
    Next P
    
    Get_RandomString = T$
        
End Function
Public Function CheckSum(Str As String, Optional ErrorNumber As Long) As String
    Dim lCtr As Long, x As Long
    Dim DatenASCII() As Byte

    On Local Error GoTo Quit

    ErrorNumber = 0

    DatenASCII = Str
  
    For lCtr = LBound(DatenASCII) To UBound(DatenASCII) Step 2
        x = (x + DatenASCII(lCtr)) And 255
    Next lCtr

    CheckSum = CStr(x)
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(mString, "CheckSum", Err.Number, Err.Description)

    Err.Clear

End Function
Public Function InStrRev(ByVal Str As String, ByVal Find As String, _
                        Optional POS As InStrPosition = itFIRST, _
                        Optional FindExact As Boolean = True) As Long
    
    InStrRev = DLL.STRING.InStr(StrReverse(Str), Find, POS, FindExact)

End Function
Public Function InStr(ByVal Str As String, Find As String, _
                      Optional POS As InStrPosition = itFIRST, _
                      Optional FindExact As Boolean = True) As Long
    Dim x As Long, P As Long, Y As Long
    
    If Not FindExact Then
        Find = LCase$(Find)
        Str = LCase$(Str)
    End If
    
    Select Case POS
        Case 0
            Exit Function
        Case itFIRST
            x = VBA.InStr(Str, Find)
        Case itLast, Is > -1
            P = 1: Y = 0

            Do While VBA.InStr(P, Str, Find)
                x = VBA.InStr(P, Str, Find)
                
                P = x + Len(Find)
                Y = Y + 1
        
                If POS > -1 Then If Y = POS Then Exit Do
            Loop
        
            If POS > -1 Then If Y < POS Then x = 0
        Case Else
            Exit Function
    End Select
    
    InStr = x
    
End Function
Public Function isValidType(ByVal Var As String, Typ As DATATYPE, _
                            Optional inclSpace As Boolean, _
                            Optional ErrorNumber As Long) As Boolean
    Dim P As Long
    Dim V$
    
    On Local Error GoTo Quit

    ErrorNumber = 0
    
    Select Case Typ
        Case dtDOUBLE
            Debug.Print CDbl(Var)
        Case dtINTEGER
            Debug.Print CInt(Var)
        Case dtLONG
            Debug.Print CLng(Var)
        Case dtNUMERIC
            Debug.Print IsNumeric(Var)
        Case dtSINGLE
            Debug.Print CSng(Var)
        Case dtBYTE
            Debug.Print CByte(Var)
        Case dtALPHA
            V$ = lABC & IIf(inclSpace, " ", "")
            Var = LCase$(Var)

            For P = 1 To Len(Var)
                If InStr(V$, mID$(Var, P, 1)) = 0 Then Exit Function
            Next P
        Case dtDATE
            isValidType = DLL.MISC.isValidDate(Var)
            Exit Function
        Case dtCURRENCY
            Debug.Print CCur(Var)
    End Select
    
    isValidType = True
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(mString, "isValidType", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function StringToBin(ByVal Str As String, Optional ErrorNumber As Long) As String()
    Dim P As Long
    Dim S() As String

    On Local Error GoTo Quit

    ErrorNumber = 0
    
    For P = 1 To Len(Str)
        ReDim Preserve S(P - 1)
        S(P - 1) = DLL.MATH.DecToBin(Asc(mID$(Str, P, 1)))
    Next P

    StringToBin = S

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(mString, "StringToBin", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function StringToByte(ByVal Str As String, Optional ErrorNumber As Long) As Byte()
    Dim P As Long, x As Long
    Dim B() As Byte
    
    On Local Error GoTo Quit

    ErrorNumber = 0

    ReDim B(Len(Str) - 1)

    For P = 1 To Len(Str)
        x = Asc(mID(Str, P, 1))
        B(P - 1) = x
    Next P

    StringToByte = B
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(mString, "StringToByte", Err.Number, Err.Description)

    Err.Clear

End Function
Public Function sSplit(ByVal Str As String, ByVal Position As Long) As String()
    Dim R() As String, S$, T$, A() As String, B() As String
    Dim P As Long
    
    On Local Error Resume Next
    
    Erase B
    Erase R
    
    A = Split(Str, vbCrLf)
    
    For P = 0 To UBound(A)
        S$ = A(P)
        
        Do While Len(S$) <> 0
            If Len(S$) <= Position Then
                Call DLL.ARRAY.Add(R, S$, arTOEND)
                S$ = ""
            Else
                T$ = Left$(S$, Position)
                Call DLL.ARRAY.Add(R, T$, arTOEND)
            
                S$ = mID(S$, Position + 1)
            End If
        Loop
            
        Call DLL.ARRAY.AddArray(B, R, arTOEND)
        
        If P = UBound(A) Then
            If Right$(Str, 2) = vbCrLf Then Call DLL.ARRAY.Add(B, "", arTOEND)
        Else
            Call DLL.ARRAY.Add(B, "", arTOEND)
        End If
                
        Erase R
    Next P
    
    sSplit = B
    
Quit:
    If Err.Number <> 0 Then Err.Clear

End Function
Public Function StringToSHA1(ByVal Str As String) As String
    Dim B_T() As Byte
    Dim Z As Long
    
    ReDim B_T(Len(Str) - 1) As Byte
    
    For Z = 0 To Len(Str) - 1
        B_T(Z) = Asc(mID(Str, Z + 1, 1))
    Next Z

    StringToSHA1 = SHA1_Bytes(B_T)

End Function
Public Function ToArray(ByVal TEXT As String, _
                        Optional StlitAt As String = vbCrLf) As Variant
    Dim L() As String
    
    L = Split(TEXT, StlitAt)
    ToArray = L
    
End Function
