VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Misc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function QueryPerformanceCounter Lib "kernel32" (lpPerformanceCount As LARGE_INTEGER) As Long
Private Declare Function QueryPerformanceFrequency Lib "kernel32" (lpFrequency As LARGE_INTEGER) As Long
Private Declare Function GetLastError Lib "kernel32" () As Long
Private Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" (ByVal dwFlags As Long, lpSource As Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, Arguments As Long) As Long
Private Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" (ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String, ByVal cchData As Long) As Long
Private Declare Function VerLanguageNameA Lib "kernel32.dll" (ByVal wLang As Long, ByVal szLang As String, ByVal nSize As Long) As Long
Private Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long

Private Declare Sub SleepA Lib "kernel32" Alias "Sleep" (ByVal dwMilliseconds As Long)

Public Enum Get_Date_Output
    gdoFORMAT_ONLY = 0
    gdoGET_DAY = 1
    gdoGET_MONTH = 2
    gdoGET_YEAR = 3
End Enum
    
Public Enum ConvertType
    coLong = 1
    coVarriant = 2
    coString = 4
    coByte = 8
    coSingle = 16
    coDate = 32
    coInteger = 64
    coCurrency = 128
    coDouble = 256
End Enum

Public Enum varType
    vtLONG
    vtBYTE
    vtDOUBLE
    vtSINGLE
    vtDATE
    vtTIME
    vtINTEGER
    vtCURRENCY
    vtDECIMAL
End Enum

Public Enum STOPCLOCKINFO
    scSTOP = 0
    scSTART = 1
    scCURRENTSTOPTIME = 2
    scSTARTTIME = 3
    scRESET = 4
End Enum

Public Enum CLOCKINFO
    msMSClock
    msNORMALCLOCK
End Enum

Public Enum WinSymbol
    wsArrow_Left = 51
    wsArrow_Right = 52
    wsArrow_Up = 53
    wsArrow_Down = 54
    wsArrow_Spin = 118
    wsArrow_Bottom = 55
    wsArrow_Small_Left = 119
    wsArrow_Small_Right = 56
    wsArrow_Small_Up = 116
    wsArrow_Small_Down = 56
    wsSymbol_Check = 97
    wsSymbol_Bullet = 104
    wsSymbol_Small_Bullet = 105
    wsSymbol_Close = 114
    wsSymbol_Help = 115
    wsSymbol_Minimize = 48
    wsSymbol_Maximize = 49
    wsSymbol_Restore = 50
End Enum

Public Enum ALIGMENT
    crTOP = &H400
    crVCENTER = &HC00
    crBOTTOM = &H800
    crLEFT = &H100
    crCENTER = &H300
    crRIGTH = &H200
End Enum

Public Enum tfFORMATTYPE
    tfYEAR = 0
    tfDAY = 1
    tfHOUR = 2
    tfMINUTE = 3
    tfSECOND = 4
End Enum

Public Type LocaleInfoType
    liCurrency As String
    liIntlSymbol As String
    liMonDecimalSep As String
    liCurrDigits As String
    liMonThousAndSep As String
    liMonGroupIng As String
End Type

Private Type LARGE_INTEGER
    Lo As Long
    Hi As Long
End Type

Public Enum DateDif
    ddSECONDS = 1
    ddMINUTES = 2
    ddHOURS = 3
    ddDAYS = 4
    ddMONTHS = 5
    ddYEARS = 6
End Enum

Dim Strt    As LARGE_INTEGER
Dim Ende    As LARGE_INTEGER
Dim Freq    As LARGE_INTEGER

'Permutation
Private strPermutation As String
Private strZeichen As String
Private intArray_Pos() As Integer
Private intArray_Pos_Zeiger As Integer
Private lngCount As Long
Private strErgebnis() As String

Dim Calibr As Double

Public Function Get_Randomize(ByVal Min As Long, ByVal Max As Long) As Long
    
    Randomize
    Get_Randomize = Rnd * (Max - Min) + Min
    
End Function
Public Function Get_RandomTrueFalse() As Boolean
    Get_RandomTrueFalse = CBool(Get_Randomize(0, 1))
End Function
Public Sub Sleep(ByVal MilliSeconds As Long)
    Call SleepA(MilliSeconds)
End Sub
Public Function Get_WeekDay(sDate As Date) As String
    
    On Local Error GoTo Quit
    
    Get_WeekDay = WeekdayName(Weekday(sDate, vbMonday))

Quit:
    If Err.Number <> 0 Then Call basPModule.ERROR(Misc_, "Get_WeekDay", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Get_Date(sDate As Date, Output As Get_Date_Output) As Variant
    Dim D As Date
    Dim L As Long
    
    Select Case Output
        Case gdoFORMAT_ONLY
            D = Format(sDate, "DD.MM.YYYY")
            Get_Date = CDate(D)
        Case gdoGET_DAY
            L = Format(sDate, "DD")
            Get_Date = CLng(L)
        Case gdoGET_MONTH
            L = Format(sDate, "MM")
            Get_Date = CLng(L)
        Case gdoGET_YEAR
            L = Format(sDate, "YYYY")
            Get_Date = CLng(L)
    End Select
    
End Function
Public Sub About()
    frmAbout.Show
End Sub
Public Function Convert_DateToUnix(ByVal uDate As Date, ByVal uTime As Date) As String
    Dim DateTimeEnd As Date
    
    On Local Error GoTo Quit
    
    DateTimeEnd = FormatDateTime(uDate & " " & uTime)
    
    Convert_DateToUnix = DateDiff("s", "01.01.1970", DateTimeEnd, vbUseSystemDayOfWeek, vbUseSystem)

Quit:
    If Err.Number <> 0 Then Call basPModule.ERROR(Misc_, "Convert_DateToUnix", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Convert_UnixToDate(ByVal UnixDate As Double) As Date
    Dim vStart As Variant
  
    On Local Error GoTo Quit
  
    vStart = DateSerial(1970, 1, 1)
    Convert_UnixToDate = DateAdd("s", UnixDate, vStart)

Quit:
    If Err.Number <> 0 Then Call basPModule.ERROR(Misc_, "Convert_UnixToDate", Err.Number, Err.Description)

    Err.Clear
    
End Function
Private Sub Calibrieren()
    
    Call QueryPerformanceFrequency(Freq)
    Call QueryPerformanceCounter(Strt)
    Call QueryPerformanceCounter(Ende)
        
    Calibr = (D(Ende) - D(Strt)) / D(Freq) * 1000
        
End Sub
Private Function RunTime() As Variant
    RunTime = (D(Ende) - D(Strt)) / D(Freq) * 1000 - Calibr
End Function
Private Function D(x As LARGE_INTEGER) As Double
    Dim L As Double, H As Double
    
    L = x.Lo
    H = x.Hi
    
    If L < 0 Then L = 4294967296# + L + 1
    If H < 0 Then H = 4294967296# + H + 1
    
    D = L + H * 4294967296#

End Function
Public Function StopClock(Clock As CLOCKINFO, Command As STOPCLOCKINFO) As Variant
        
    Static sDate As Date, s2Date As Date
    
    Select Case Clock
        Case msNORMALCLOCK
            Select Case Command
                Case scCURRENTSTOPTIME
                    StopClock = Format$((Now - s2Date), "hh:mm:ss")
                Case scSTART, scRESET
                    s2Date = TIME
                    StopClock = s2Date
                Case scSTARTTIME
                    StopClock = s2Date
                Case scSTOP
                    StopClock = Format$((Now - s2Date), "hh:mm:ss")
                    s2Date = CDate(0)
            End Select
        Case msMSClock
            Select Case Command
                Case scRESET, scSTART
                    Call Calibrieren
                    Call QueryPerformanceCounter(Strt)
            
                    StopClock = TIME
                    sDate = StopClock
                Case scSTARTTIME
                    StopClock = sDate
                Case scSTOP
                    Call QueryPerformanceCounter(Ende)
                    StopClock = Format(RunTime, "0.00")
            End Select
    End Select
    
    Err.Clear
    
End Function
Public Function isLeapYear(ByVal Year As Long) As Boolean
    isLeapYear = IsDate("02/29/" & Year)
End Function
Public Function VarSwap(Var1 As Variant, Var2 As Variant) As Long
    Dim V As Variant
    
    On Local Error GoTo Quit
    
    V = Var1
    
    Var1 = Var2
    Var2 = V

Quit:
    VarSwap = Err.Number

    If Err.Number <> 0 Then Call basPModule.ERROR(Misc_, "VarSwap", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Log(ByVal LogText As String, _
                    Optional LogFile As String, _
                    Optional FileSizeLimit As Long = 0) As String
    Dim D$, R$, S$, LF As String
    Dim L As Long, FN As Long
       
    On Local Error GoTo Quit
    
    If LogText = "" Then
        R$ = vbCrLf
    Else
        D$ = DATE & " / " & TIME & " -> "
        L = Len(D$)
        S$ = STRING(L, " ")
    
        LogText = Replace(LogText, vbCrLf, vbCrLf & S$)
    
        R$ = D$ & LogText
        If Right$(R$, 2) = vbCrLf Then R$ = mID(R$, 1, Len(R$) - 2)
    End If
    
    Log = R$
    LF = ""
    
    If DebugLogFilePath <> "" Then LF = DebugLogFilePath
    If LogFile <> "" Then LF = LogFile
    
    If FileSizeLimit > 0 Then
        S$ = DLL.Text.TextFile_Read(LF)
        
        If S$ <> "" Then
            S$ = S$ & vbCrLf & R$
        Else
            S$ = R$
        End If
        
        Call DLL.File.fKill(LF)

        If Len(S$) > FileSizeLimit Then S$ = Right$(S$, FileSizeLimit)
        
        R$ = S$
    End If
    
    If LF <> "" Then
        FN = FreeFile
    
        Open LF For Append As FN
            Print #FN, R$
        Close FN
    End If
    
Quit:
    If Err.Number <> 0 Then Call basPModule.ERROR(Misc_, "Log", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Get_WinSymbol(Symbol As WinSymbol) As String
        
    On Local Error GoTo Quit
    
    Get_WinSymbol = Chr$(Symbol)
    
Quit:
    If Err.Number <> 0 Then Call basPModule.ERROR(Misc_, "Get_WinSymbol", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Get_DayOfMonthCount(ByVal Month As Long, ByVal Year As Long) As Long
    Dim P As Long
        
    On Local Error GoTo Quit

    For P = 31 To 1 Step -1
        If IsDate(CStr(P) & "." & CStr(Month) & "." & CStr(Year)) Then Get_DayOfMonthCount = P: _
                                                                       Exit Function
    Next P

Quit:
    Get_DayOfMonthCount = (Err.Number * -1)

    If Err.Number <> 0 Then Call basPModule.ERROR(Misc_, "Get_DayOfMonthCount", Err.Number, Err.Description)

    
    Err.Clear

End Function
Public Function Time_Format(ByVal lngInputValue As Currency, _
                            Optional sInputType As tfFORMATTYPE = tfSECOND, _
                            Optional ByVal sFormat As String = "hh:mm:ss", _
                            Optional sMaxValue As tfFORMATTYPE = tfDAY) As String
    Dim dd As String, dh As String, dm As String, Ds As String, dy As String
    Dim Textd As String, Texth As String, Textm As String, Texts As String, Texty As String
    Dim D As Currency, H As Currency, M As Currency, S As Currency, Y As Currency
    Dim iMaxValue As tfFORMATTYPE
    
    On Local Error GoTo Quit
    
    sFormat = LCase$(sFormat)
    
    sFormat = Replace(sFormat, "d$", "(0)")
    sFormat = Replace(sFormat, "h$", "(1)")
    sFormat = Replace(sFormat, "m$", "(2)")
    sFormat = Replace(sFormat, "s$", "(3)")
    sFormat = Replace(sFormat, "y$", "(4)")
    sFormat = Replace(sFormat, "&", "(&)")

    Select Case sInputType
        Case tfMINUTE: lngInputValue = lngInputValue * 60
        Case tfHOUR:   lngInputValue = lngInputValue * 3600
        Case tfDAY:    lngInputValue = lngInputValue * 86400
        Case tfYEAR:   lngInputValue = lngInputValue * 86400
                       lngInputValue = CCur(lngInputValue) * CCur(365)
        Case tfSECOND: 'Nope
        Case Else:     Exit Function
    End Select
    
    iMaxValue = sMaxValue
    
    If iMaxValue = tfYEAR Then Y = Int(lngInputValue / 86400 / 365): _
                               lngInputValue = lngInputValue - (86400 * 365 * Y)
    If iMaxValue <= tfDAY Then D = Int(lngInputValue / 86400): _
                               lngInputValue = lngInputValue - (86400 * D)
    If iMaxValue <= tfHOUR Then H = Int(lngInputValue / 3600): _
                                lngInputValue = lngInputValue - (3600 * H)
    If iMaxValue <= tfMINUTE Then M = Int(lngInputValue / 60): _
                                  lngInputValue = lngInputValue - (60 * M)
        
    S = lngInputValue
  
    dy = Format$(Y, "00")
    dd = Format$(D, "00")
    dh = Format$(H, "00")
    dm = Format$(M, "00")
    Ds = Format$(S, "00")
  
    sFormat = Replace(sFormat, "yy", dy)
    sFormat = Replace(sFormat, "y", Y)
    sFormat = Replace(sFormat, "dd", dd)
    sFormat = Replace(sFormat, "d", D)
    sFormat = Replace(sFormat, "hh", dh)
    sFormat = Replace(sFormat, "h", H)
    sFormat = Replace(sFormat, "mm", dm)
    sFormat = Replace(sFormat, "m", M)
    sFormat = Replace(sFormat, "ss", Ds)
    sFormat = Replace(sFormat, "s", S)
  
    If D = 1 Then Textd = " Tag" Else Textd = " Tage"
    If H = 1 Then Texth = " Stunde" Else Texth = " Stunden"
    If M = 1 Then Textm = " Minute" Else Textm = " Minuten"
    If S = 1 Then Texts = " Sekunde" Else Texts = " Sekunden"
    If Y = 1 Then Texty = " Jahr" Else Texty = " Jahre"
    
    Textd = CStr(dd) & Textd
    Texth = CStr(dh) & Texth
    Textm = CStr(dm) & Textm
    Texts = CStr(Ds) & Texts
    Texty = CStr(dy) & Texty
    
    sFormat = Replace(sFormat, "(0)", Textd)
    sFormat = Replace(sFormat, "(1)", Texth)
    sFormat = Replace(sFormat, "(2)", Textm)
    sFormat = Replace(sFormat, "(3)", Texts)
    sFormat = Replace(sFormat, "(4)", Texty)
    sFormat = Replace(sFormat, "(&)", " und ")
  
    Time_Format = sFormat

Quit:
    If Err.Number <> 0 Then Call basPModule.ERROR(Misc_, "Time_Format", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Permutation(ByVal Str As String, _
                            Optional ShowProgress As Boolean = False) As String()
    Dim frm As New ProgBar
    
    If ShowProgress Then
        Load frm
        
        frm.Frame1.Caption = "Permutation wird berechnet..."
        frm.Message.Caption = "Bitte warten..."
        frm.Picture1.Visible = False
        
        Call DLL.FORMS.Center(frm, ccMIDDLE)
        Call DLL.FORMS.StayOnTop(frm)

        frm.Visible = True
        frm.Refresh
        DoEvents
    End If
    
    strZeichen = Str
    intArray_Pos_Zeiger = -1
    lngCount = -1
    
    ReDim intArray_Pos(Len(strZeichen) - 1)
    Call sPermutation(0, ShowProgress, frm)
    
    Permutation = strErgebnis()
    
    Erase intArray_Pos
    Erase strErgebnis
    
    If ShowProgress Then
        Unload frm
        Set frm = Nothing
    End If
    
End Function
Private Sub sPermutation(intX As Integer, ShowProgress As Boolean, frm As Object)
    Dim i As Integer
  
    intArray_Pos_Zeiger = intArray_Pos_Zeiger + 1
    intArray_Pos(intX) = intArray_Pos_Zeiger
  
    If intArray_Pos_Zeiger = Len(strZeichen) Then
        strPermutation = ""
        
        For i = 0 To UBound(intArray_Pos)
            strPermutation = strPermutation & mID$(strZeichen, intArray_Pos(i), 1)
        Next i
    
        lngCount = lngCount + 1
        ReDim Preserve strErgebnis(lngCount)
        
        strErgebnis(lngCount) = strPermutation
        
        If ShowProgress Then
            frm.Message.Caption = strPermutation & vbCrLf & _
                                  CStr(UBound(strErgebnis) + 1) & " Kombinationen"
            
            'frm.Message.Refresh
            DoEvents
        End If
    Else
        For i = 0 To Len(strZeichen) - 1
            If intArray_Pos(i) = 0 Then Call sPermutation(i, ShowProgress, frm)
        Next i
    End If
  
    intArray_Pos_Zeiger = intArray_Pos_Zeiger - 1
    intArray_Pos(intX) = 0

End Sub
Public Function DateDifference(ByVal Date1 As Date, ByVal Date2 As Date, DifferenceFormat As DateDif) As Long
    Dim D As Long, H As Long, M As Long, S As Long, R As Long
    Dim i As Double
    Dim T As Date
    Dim SP() As String
    
    On Local Error GoTo Quit
    
    D = DateValue(Date1) - DateValue(Date2)
    
    i = TimeValue(Date1) - TimeValue(Date2)
    T = Format(i, "hh:mm:ss")
    SP = Split(T, ":")
    
    H = CLng(SP(0))
    M = CLng(SP(1))
    S = CLng(SP(2))
    
    Select Case DifferenceFormat
        Case ddSECONDS
            R = (D * 24 * 60 * 60) + (H * 60 * 60) + (M * 60) + S
        Case ddMINUTES
            R = (D * 24 * 60) + (H * 60) + M
        Case ddHOURS
            R = (D * 24) + H
        Case ddDAYS
            R = D
        Case ddMONTHS
            R = (D / 30)
        Case ddYEARS
            R = (D / 360)
    End Select

    DateDifference = R
    
Quit:
    If Err.Number <> 0 Then
        DateDifference = (Err.Number * -1)
    
        Call basPModule.ERROR(Misc_, "DateDifference", Err.Number, Err.Description)
    End If
    
    Err.Clear
    
End Function
Public Sub SetDebugInfo(ByVal DebugModeIsEnabled As Boolean, ByVal ShowMessage As Boolean, _
                        ByVal ShowMessageOnly As Boolean, ByVal LogFilePath As String)
    Dim Index As Long
    Dim frm As Form
    Dim R$, S$
    Dim PathChanged As Boolean
    
    Static oldPath  As String
    
    On Local Error Resume Next
    
    DebugShowMSG = ShowMessage
    DebugDebugModus = DebugModeIsEnabled
    DebugLogFilePath = LogFilePath
    DebugShowMSGonly = ShowMessageOnly
    
    Index = DLL.FORMS.Find_Form(FORMS, "frmdebug", ffFormName, frm, False)
    
    If oldPath <> "" And (oldPath <> LogFilePath) Then PathChanged = True
    
    If LogFilePath <> "" Then
        R$ = DATE & " / " & TIME & " -> >>>>> Set LogFile to " & LogFilePath & " <<<<<"
    Else
        R$ = DATE & " / " & TIME & " -> >>>>> Stopping writing LogFile <<<<<"
    End If
    
    If (Not DebugModeIsEnabled) Then
        If Index > -1 Then Unload frmDebug
    Else
        If Index > -1 Then
            frm.txtDebug.Text = frm.txtDebug.Text & vbCrLf & R$
            frm.txtDebug.SelStart = Len(frm.txtDebug.Text)
            
            If LogFilePath = "" Then
                S$ = "<No LogFile Selected>"
                frm.butLogFile.Enabled = False
            Else
                S$ = LogFilePath
                frm.butLogFile.Enabled = True
            End If
            
            frm.txtPath.Text = S$
        End If
    End If
    
    Set frm = Nothing

    If ((oldPath <> LogFilePath) And oldPath <> "") Then
        Call DLL.Text.TextFile_AddText(oldPath, R$, Add_to_End)
        
        If LogFilePath <> "" Then
            Call DLL.Text.TextFile_AddText(LogFilePath, ">>>>> Continue Log from " & oldPath & " <<<<<" & vbCrLf & vbCrLf, Add_to_End)
        End If
    End If

    oldPath = LogFilePath
       
    Err.Clear
    
End Sub
Public Function ERROR(ByVal Routine As String, _
                      ByVal ErrorNumber As Long, ByVal ErrorText As String, _
                      Optional UserMessage As String, _
                      Optional LogFile As String) As String
    Dim D$, R$, S$, A$, LF As String
    Dim L As Long, FN As Long
    
    On Local Error GoTo Quit
    
    D$ = DATE & " / " & TIME & " -> "
    L = Len(D$)
    S$ = STRING(L, " ")
    
    R$ = D$ & "ERROR " & ErrorNumber & vbCrLf
    
    If Routine <> "" Then
        A$ = S$ & "Routine: " & Routine & vbCrLf
    Else
        A$ = ""
    End If
    
    R$ = R$ & A$

    If ErrorText <> "" Then R$ = R$ & S$ & ErrorText & vbCrLf
    If UserMessage <> "" Then R$ = R$ & S$ & UserMessage & vbCrLf

    If Right$(R$, 2) = vbCrLf Then R$ = mID(R$, 1, Len(R$) - 2)
    
    ERROR = R$
    LF = ""
    
    If DebugLogFilePath <> "" Then LF = DebugLogFilePath
    If LogFile <> "" Then LF = LogFile
    
    If DebugDebugModus Then
        frmDebug.txtDebug.Text = frmDebug.txtDebug.Text & R$
        frmDebug.txtDebug.SelStart = Len(frmDebug.txtDebug.Text)
    
        If LF = "" Then
            frmDebug.butCopy.Visible = False
            frmDebug.txtPath.Visible = False
            frmDebug.butLogFile.Visible = False
        Else
            frmDebug.txtPath.Text = LF
        End If
    End If

    If LF <> "" Then
        FN = FreeFile
    
        Open LF For Append As FN
            Print #FN, R$
        Close FN
    End If
    
Quit:
    If Err.Number <> 0 Then Call basPModule.ERROR(Misc_, "ERROR", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function isValidType(ByVal sInput As Variant, sType As VbVarType) As Boolean
    Dim goExit As Boolean
    
    On Local Error Resume Next
    
    goExit = False
    
    Select Case sType
        Case vbUserDefinedType, vbEmpty, vbNull
            Dim vt As VbVarType
            
            vt = VBA.varType(sInput)
            isValidType = (vt = sType)
            goExit = True
        
        Case vbDate:            isValidType = isValidDate(sInput)
                                goExit = True
        Case vbArray:           isValidType = DLL.ARRAY.isArray(sInput)
                                goExit = True
        Case vbObject:          Dim Obj As Object
                                Set Obj = sInput
                                Set Obj = Nothing

        Case vbDouble:   Debug.Print CDbl(sInput)
        Case vbInteger:  Debug.Print CInt(sInput)
        Case vbLong:     Debug.Print CLng(sInput)
        Case vbSingle:   Debug.Print CSng(sInput)
        Case vbByte:     Debug.Print CByte(sInput)
        Case vbCurrency: Debug.Print CCur(sInput)
        Case vbDecimal:  Debug.Print CDec(sInput)
        Case vbBoolean:  Debug.Print CBool(sInput)
        Case vbString:   Debug.Print CStr(sInput)
    End Select
    
    If Not goExit Then
        If Err.Number = 0 Then isValidType = True
    End If
    
    Err.Clear
    
End Function
Public Function isValidDate(ByVal sInput As String) As Boolean
    Dim R$, A() As String
    Dim P As Long, L As Long, x As Long
    Dim D As Date
    Dim B As Byte
    
    On Local Error Resume Next
    
    D = CDate(sInput)
    
    If Err.Number <> 0 Then Err.Clear: _
                            Exit Function

    R$ = sInput
    A = Split(R$, ".")

    If UBound(A) <> 2 Then Exit Function

    For P = 0 To UBound(A)
        R$ = A(P)
        
        L = 2
        If P = 2 Then L = 4
        
        If Len(R$) > L Or Len(R$) < 1 Then Exit Function
        If Not IsNumeric(R$) Then Exit Function
        
        Err.Clear
        
        If L = 2 Then
            B = CByte(R$)
            If Err.Number <> 0 Then Err.Clear: _
                                    Exit Function
                  
            If B > 31 Or B < 1 Then Exit Function
        Else
            x = CLng(R$)
            If Err.Number <> 0 Then Err.Clear: _
                                    Exit Function
            If x < 1 Then Exit Function
        End If
    Next P
    
    isValidDate = True
    
End Function
Public Function isValidTime(ByVal sInput As String) As Boolean
    Dim R$, A() As String
    Dim P As Long, L As Long
    Dim B As Byte
    Dim D As Date
    
    On Local Error Resume Next
    
    D = CDate(sInput)
    
    If Err.Number <> 0 Then Err.Clear: _
                            Exit Function

    R$ = sInput
    A = Split(R$, ":")
    
    If UBound(A) <> 2 Then Exit Function
    
    For P = 0 To UBound(A)
        R$ = A(P)
        
        If Len(R$) > 2 Or Len(R$) < 1 Then Exit Function
        If Not IsNumeric(R$) Then Exit Function
        
        Err.Clear
        
        B = CByte(R$)
        
        If Err.Number <> 0 Then
            Err.Clear
            Exit Function
        End If
        
        L = 59
        If P = 0 Then L = 24
    
        If B > L Or B < 0 Then Exit Function
    Next P
    
    isValidTime = True
    
End Function
Public Function Convert(ByVal Data As Variant, TypeOutput As ConvertType, Optional ErrorNumber As Long) As Variant
    
    On Local Error GoTo Quit
    
    Select Case TypeOutput
        Case coLong:     Convert = CLng(Data)
        Case coVarriant: Convert = CVar(Data)
        Case coString:   Convert = CStr(Data)
        Case coByte:     Convert = CByte(Data)
        Case coDate:     Convert = CDate(Data)
        Case coSingle:   Convert = CSng(Data)
        Case coInteger:  Convert = CInt(Data)
        Case coCurrency: Convert = CCur(Data)
        Case coDouble:   Convert = CDbl(Data)
    End Select
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    If Err.Number <> 0 Then Call basPModule.ERROR(Misc_, "Convert", Err.Number, Err.Description)
    
    Err.Clear

End Function
Public Function Get_WeekOfYear(ByVal sDate As Date) As Long
    Dim xt As Double
 
    On Local Error GoTo Quit

    xt = DateSerial(Year(sDate + (8 - Weekday(sDate)) Mod 7 - 3), 1, 1)
    Get_WeekOfYear = (sDate - xt - 3 + (Weekday(xt) + 1) Mod 7) \ 7 + 1

    Exit Function
    
Quit:
    Get_WeekOfYear = (Err.Number * -1)

    Call basPModule.ERROR(Misc_, "Get_WeekOfYear", Err.Number, Err.Description)
        
    Err.Clear

End Function
Public Function Verison() As String
    Verison = App.Major & "." & App.Minor & "." & App.Revision
End Function
Public Function LastSystemMessage() As String
    Dim Buffer As String
    
    Const FORMAT_MESSAGE_FROM_SYSTEM = &H1000
    Const LANG_NEUTRAL = &H0
    Const FORMAT_MESSAGE_IGNORE_INSERTS = &H200
    
    Buffer = Space(200)
    
    FormatMessage FORMAT_MESSAGE_FROM_SYSTEM Or FORMAT_MESSAGE_IGNORE_INSERTS, ByVal 0&, _
                  GetLastError, LANG_NEUTRAL, Buffer, 200, ByVal 0&
    
    LastSystemMessage = Buffer

End Function
 Public Function Get_LocaleInfo() As LocaleInfoType
    Dim Buffer As String * 100
    Dim Retval As Long
    Dim Li As LocaleInfoType
    
    Const LOCALE_SCURRENCY = &H14
    Const LOCALE_SINTLSYMBOL = &H15
    Const LOCALE_SMONDECIMALSEP = &H16
    Const LOCALE_SMONTHOUSANDSEP = &H17
    Const LOCALE_SMONGROUPING = &H18
    Const LOCALE_ICURRDIGITS = &H19
    Const LOCALE_USER_DEFAULT = &H400
    
    Retval = GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SCURRENCY, Buffer, 99)
    Li.liCurrency = ConvNull(Buffer)
    Retval = GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SINTLSYMBOL, Buffer, 99)
    Li.liIntlSymbol = ConvNull(Buffer)
    Retval = GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SMONDECIMALSEP, Buffer, 99)
    Li.liMonDecimalSep = ConvNull(Buffer)
    Retval = GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_ICURRDIGITS, Buffer, 99)
    Li.liCurrDigits = ConvNull(Buffer)
    Retval = GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SMONTHOUSANDSEP, Buffer, 99)
    Li.liMonThousAndSep = ConvNull(Buffer)
    Retval = GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SMONGROUPING, Buffer, 99)
    Li.liMonGroupIng = ConvNull(Buffer)

    Get_LocaleInfo = Li

End Function
Private Function ConvNull(ByVal sString As String)
    Dim POS As Long
  
    POS = InStr(sString, Chr$(0))
    ConvNull = IIf(POS > 0, Left$(sString, POS - 1), "")

End Function
Public Function Get_AllLanguages() As String()
    Dim i As Long, j As Long, sLen As Long, lcid As Long, x As Long
    Dim sLCItem As String, sH As String, sItem As String, sBuf As String * 256, R() As String
    Dim HashCol As New Collection

    x = 0

    For i = 0 To &HFF
        For j = 0 To &H10
            lcid = j * &H400 + i
            sLen = VerLanguageNameA(lcid, sBuf, 256)
            
            If sLen > 0 Then
                sLCItem = Left$(sBuf, sLen)
                
                If Not IsInList(HashCol, sLCItem) Then
                    sH = Hex$(lcid)
                    sH = STRING$(4 - Len(sH), "0") & sH
                    sItem = "&H" & sH & "   " & sLCItem
                    
                    ReDim Preserve R(x)
                    R(x) = sItem
                    
                    x = x + 1
                End If
            End If
        Next j
    Next i

    Get_AllLanguages = R$
    
End Function
Private Function IsInList(aCol As Collection, strKey As String) As Boolean
  
    On Local Error GoTo Quit
  
    Call aCol.Add(strKey, strKey)
    If Err.Number = 0 Then Exit Function
  
Quit:
    IsInList = True

    Err.Clear

End Function
Public Function IsFunctionExported(ByVal Module As String, _
                                   ByVal FunctionName As String) As Boolean
    Dim hMod As Long, Loaded As Boolean
    
    hMod = GetModuleHandle(Module)
    
    If hMod = 0 Then
        hMod = LoadLibrary(Module)
        If hMod Then Loaded = True
    End If
    
    If hMod Then
        If GetProcAddress(hMod, FunctionName) Then IsFunctionExported = True
    End If
    
    If Loaded Then Call FreeLibrary(hMod)

End Function
